// ignore_for_file: camel_case_types

library ags_authrest;

import 'dart:convert';
import 'package:dart_jsonwebtoken/dart_jsonwebtoken.dart';
import 'package:crypto/crypto.dart';
import 'package:intl/intl.dart';
import 'package:encrypt/encrypt.dart';

class Ags_restauth {
  // ignore: non_constant_identifier_names
  late String SECERT_JWT;
  // ignore: non_constant_identifier_names
  late String R_USER;

  genH() {
    DateTime now = DateTime.now().toUtc();
    String formattedDate = DateFormat('MM/dd').format(now);
    var key = utf8.encode(SECERT_JWT);
    var bytes = utf8.encode(formattedDate);
    var hmacSha256 = Hmac(sha256, key);
    var result = hmacSha256.convert(bytes);
    return result.toString();
  }

  String genToken() {
    final jwt = JWT(
        {"sub": R_USER, "iat": DateTime.now().toUtc().millisecondsSinceEpoch});
    var token = jwt.sign(SecretKey(genH()));

    return token;
  }

  String genTokenEncryp() {
    final jwt = JWT(
        {"sub": R_USER, "iat": DateTime.now().toUtc().millisecondsSinceEpoch});
    var token = jwt.sign(SecretKey(genH()));

    return encrypHeader(token).replaceAll('/', 'securityAgs');
  }

  String encrypHeader(bodystr) {
    final key = Key.fromUtf8(genH().substring(0, 32));
    final iv = IV.fromUtf8(genH().substring(0, 16));
    final encrypter = Encrypter(AES(key, mode: AESMode.cbc));
    final encrypted = encrypter.encrypt(bodystr, iv: iv);
    return encrypted.base64;
  }

  Map<String, String> encrypbody(bodystr) {
    final key = Key.fromUtf8(genH().substring(0, 32));
    final iv = IV.fromUtf8(genH().substring(0, 16));
    final encrypter = Encrypter(AES(key, mode: AESMode.cbc));
    final encrypted = encrypter.encrypt(bodystr, iv: iv);
    var result = {"encrypData": encrypted.base64};
    // print(result);
    return result;
  }
}
